﻿Option Strict On
Imports Microsoft.Reporting.WinForms

Public Class BerichtsVerwaltung
    Dim Berichte As String() = {"Personal", "Kunden"} ' hier sämtliche Berichte angeben...

    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        Me.DtsNordwind.ReadXml("..\..\Nordwind.xml")

        Dim listOrt = (From l In DtsNordwind.Personal Select l.Ort).Distinct
        cbxOrt.Items.Add(String.Empty) : cbxOrt.Items.AddRange(listOrt.ToArray)
        Dim listLand = (From l In DtsNordwind.Kunden Select l.Land).Distinct
        cbxLand.Items.Add(String.Empty) : cbxLand.Items.AddRange(listLand.ToArray)
        
        cbxBerichte.Items.AddRange(Berichte)
        cbxBerichte.SelectedIndex = 0 ' den ersten Bericht zur Anzeige bringen
    End Sub

    Private Sub cbx_SelectedIndexChanged(sender As System.Object, e As System.EventArgs) _
        Handles cbxBerichte.SelectedIndexChanged,
                cbxLand.SelectedIndexChanged,
                cbxOrt.SelectedIndexChanged

        Dim Bericht As String = getItem(cbxBerichte)
        Select Case True
            Case sender Is cbxBerichte
                Select Case Bericht
                    Case Is = "Personal"
                        Me.cbxOrt.Enabled = True
                        Me.cbxLand.Enabled = False
                        Me.PersonalBindingSource.RemoveFilter()
                        bindReport(Bericht, Me.PersonalBindingSource) 'Bindingsource zuweisen
                    Case Is = "Kunden"
                        Me.cbxLand.Enabled = True
                        Me.cbxOrt.Enabled = False
                        bindReport(Bericht, DtsNordwind.Kunden) 'Tabelle zuweisen
                End Select
            Case sender Is cbxOrt
                Dim Ort = getItem(cbxOrt)
                If String.IsNullOrEmpty(Ort) Then
                    Me.PersonalBindingSource.RemoveFilter()
                Else
                    Me.PersonalBindingSource.Filter = String.Concat("Ort = '", Ort, "'"c)
                End If
                bindReport(Bericht, PersonalBindingSource) 'gefilterte Bindingsource zuweisen
            Case sender Is cbxLand
                Dim Land = getItem(cbxLand)
                If String.IsNullOrEmpty(Land) Then
                    bindReport(Bericht, DtsNordwind.Kunden) 'Tabelle zuweisen
                Else
                    bindReport(Bericht, (From x In DtsNordwind.Kunden Where x.Land = Land).AsDataView) ' DataView zuweisen
                End If
        End Select
    End Sub

    Private Sub bindReport(DataName As String, Datasource As Object)
        Dim rds As ReportDataSource = New ReportDataSource()
        rds.Name = DataName 'Name der Berichtsdatenquelle (ist auch ein Teil des Reportnamens)
        rds.Value = Datasource
        With Me.prtReportViewer
            .LocalReport.DataSources.Clear()
            .LocalReport.DataSources.Add(rds)
            .LocalReport.ReportEmbeddedResource = String.Concat("ReportViewerTutorial.Report_", DataName, ".rdlc") 'in Resource eingebetteter Bericht
            .RefreshReport()
        End With
    End Sub

    Private Function getItem(cbx As ComboBox) As String
        If cbx.SelectedItem Is Nothing Then Return String.Empty Else Return cbx.SelectedItem.ToString
    End Function

End Class